/*
 *  Copyright 2013 Anyware Services
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

Ext.namespace('org.ametys.skinfactory.ribbon');

org.ametys.skinfactory.ribbon.PassiveToolTab = function(id, configuration, pluginName, tabPanel) 
{
	org.ametys.skinfactory.ribbon.PassiveToolTab.superclass.constructor.call(this, id, configuration, pluginName, tabPanel);
};

Ext.extend(org.ametys.skinfactory.ribbon.PassiveToolTab, org.ametys.cms.ribbon.tab.ToolTab, {});


/**
 * Activate or deactivate the tab depending on the selection
 * @param {org.ametys.messagebus.message.Message[]} messages The messages received.
 * @private
 */
org.ametys.skinfactory.ribbon.PassiveToolTab.prototype.onMessage = function (messages)
{
	for (var i=messages.length-1; i >= 0; i--)
	{
		var targets = messages[i].getTargets();
		if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_TOOLFOCUSES)
		{
			var target = org.ametys.messagebus.message.MessageTargetHelper.findFirst(targets, this._testTarget.createDelegate(this));
			
			if (target == null)
			{
				this.hide();
			}
			else
			{
				this.show(false);
			}
		}
		else if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_TOOLCLOSED
			|| messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_TOOLBLUR)
		{
			var target = org.ametys.messagebus.message.MessageTargetHelper.findFirst(targets, this._testTarget.createDelegate(this));
			if (target != null)
			{
				// hides tab if visible
				this.hide();
			}
		}
	}
}

