/*
 *  Copyright 2013 Anyware Services
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

Ext.namespace('org.ametys.skinfactory.ribbon');

/**
 * Create the control instance.
 * @param {String} id The unique identifier
 * @param {Map<id, value>} configuration The configuration of the control instance.
 * @param {String} pluginName The name of the declaring plugin
 * @class This class implements the behavior for unique instance tool. These are toggle buttons showing hiding the tool.
 * @extends org.ametys.ribbon.control.RibbonControl
 */
org.ametys.skinfactory.ribbon.SkinFactoryToolButton = function(id, configuration, pluginName)
{
	org.ametys.skinfactory.ribbon.SkinFactoryToolButton.superclass.constructor.call(this, id, configuration, pluginName);
}

Ext.extend(org.ametys.skinfactory.ribbon.SkinFactoryToolButton, org.ametys.ribbon.control.button.UniqueInstanceToolButton, {});

/**
 * @private
 * This handler is called when the toogle button state change
 */
org.ametys.skinfactory.ribbon.SkinFactoryToolButton.prototype.onToggle = function(button, state)
{
	var control = org.ametys.ribbon.RibbonManager.getInstance().getControls()[this.controlId];
	if (state)
	{
		if (control.getConfiguration()['action'] != null)
		{
			eval(control.getConfiguration()['action'] + "(control.getId(), control.getConfiguration(), control.getPluginName());");
		}
	}
	else
	{
		var tool = org.ametys.uitool.ToolsManager.getInstance().getTool(control.getConfiguration()['role']);
		if (tool != null)
		{
			if (tool.toolsPanel.getActiveTab() != tool.parent)
			{
				org.ametys.uitool.ToolsManager.getInstance().activateTool (tool, tool._factory._config['default-location']);
				this.toggle(true, true);
			}
			else
			{
				tool.close(true);
			}
		}
	}
}

